#ifdef __cplusplus
extern "C" {
#endif

#ifndef DllImport
#define DllImport   __declspec( dllimport )
#endif


#ifndef DllExport
#define DllExport   __declspec( dllexport )
#endif


#ifndef DLGC_SYNTEL_API
#define DLGC_SYNTEL_API DllImport
#endif

typedef int (*PFUNC)(int dev);
typedef int (*PWAITFUNC)(int dev, BOOL *Waiting);
typedef BOOL (*PMAPFUNC) (char *, char *);


DLGC_SYNTEL_API int __cdecl li_attendant(PVOID pvParam);
DLGC_SYNTEL_API BOOL li_islicensed_syntellect(int nDev);

//
// These defines are used for versioning of the data structure.  These
// should not be changes and and the next version of the structure 
// should define a DX_ATTENDANT_SIZE_V2 and update 
// #define DX_ATTENDANT_SIZE  DX_ATTENDANT_SIZE_V2
// Then in the code for li_attendant one can check the nSize member
// and NOT use the newly added members when they are used with and app
// that was compiled with an older version of the structure.
// for example if a new struct member nFoo was added li_attendant would 
// look like
//
// if (pAtt->nSize == DX_ATTENDANT_SIZE_V2)
// {
//    fooVar = pAtt->nFoo;
// }
// // otherwise we have a struct of size DX_ATTENDANT_SIZE_V1
// // and nFoo member is not available.  Do try to access it!!!
//

#define DX_ATTENDANT_SIZE_V1  312 // used for versioning the structure

#define DX_ATTENDANT_SIZE  DX_ATTENDANT_SIZE_V1

typedef struct {
   int nSize;
	char szDevName[15];
	PFUNC pfnDisconnectCall;
	PFUNC pfnAnswerCall;
	PWAITFUNC pfnWaitForRings;
   PMAPFUNC pfnExtensionMap;
	char szEventName[MAX_PATH+1];
	int nExtensionLength;
   int nTimeOut; // in secs.
	int nDialStringLength;
} DX_ATTENDANT, *PDX_ATTENDANT;


#ifdef __cplusplus
}
#endif
