//
//  Copyright (c) 2001-2007 by AudioCodes USA, Inc.
//  All rights reserved.
//
//  NTiEventCC.h
//      SmartWORKS CallConnection API event definition file
//
//  AUDIOCODES USA, INC. PROPRIETARY.
//

#ifndef _INC_NTIEVENTCC_H
#define _INC_NTIEVENTCC_H



//-----------------------------------------------------------------------------
//                Event type codes for Call Control
//-----------------------------------------------------------------------------

#define EVT_CALL_SETUP              105 // Extended Call Information
#define EVT_CC_CALL_SETUP           EVT_CALL_SETUP


#define EVT_CALL_IN_PROGRESS        107 // ISDN Call Progress
#define EVT_CC_CALL_IN_PROGRESS     EVT_CALL_IN_PROGRESS

#define EVT_CALL_ALERTING           110 // ISDN Call Alerting
#define EVT_CC_CALL_ALERTING        EVT_CALL_ALERTING

#define EVT_CALL_CONNECTED          111 // ISDN Call Connected
#define EVT_CC_CALL_CONNECTED       EVT_CALL_CONNECTED

#define EVT_CALL_RELEASED           112 // ISDN Call RELEASAD
#define EVT_CC_CALL_RELEASED        EVT_CALL_RELEASED

#define EVT_CALL_SUSPENDED          113 // ISDN Call Suspended
#define EVT_CC_CALL_SUSPENDED       EVT_CALL_SUSPENDED

#define EVT_CALL_RESUMED            114 // ISDN Call Resumed
#define EVT_CC_CALL_RESUMED         EVT_CALL_RESUMED

#define EVT_CALL_HELD               115 // ISDN Call Held
#define EVT_CC_CALL_HELD            EVT_CALL_HELD

#define EVT_CALL_RETRIEVED          116 // ISDN Call retieved from Hold
#define EVT_CC_CALL_RETRIEVED       EVT_CALL_RETRIEVED

#define EVT_CALL_ABANDONED          117 // ISDN Call abandoned by the caller
#define EVT_CC_CALL_ABANDONED       EVT_CALL_ABANDONED

#define EVT_CALL_REJECTED           118 // ISDN Call rejected by destination
#define EVT_CC_CALL_REJECTED        EVT_CALL_REJECTED

#define EVT_USER_INFO               119 // ISDN USER INFO
#define EVT_CC_USER_INFO            EVT_USER_INFO
#define EVT_CC_USERINFO_IND         EVT_USER_INFO

#define EVT_ISDN_SUPPL_SERVICES     104 // ISDN Supplementary Services
#define EVT_CC_ISDN_SUPPL_SERVICES  EVT_ISDN_SUPPL_SERVICES

#define EVT_EXT_CALL_INFO           106 // Extended Call Information
#define EVT_CC_EXT_CALL_INFO        EVT_EXT_CALL_INFO

#define EVT_CC_RESUME_CONF          108 // Resume Confirmation
#define EVT_CC_SUSPEND_CONF         109 // Suspend Confirmation

#define EVT_CC_CONNECT_IND          120 // Incoming call Indication
#define EVT_CC_INFO_IND             121 // called party digits
#define EVT_CC_PROGRESS_IND         122 // call progress indication
#define EVT_CC_DISC_IND             123 // Disconnect Indication
#define EVT_CC_DISC_CONF            124 // Disconnect Confirmation
#define EVT_CC_CONNECT_CONF         125 // Connect Confirmation
#define EVT_CC_ALERT_IND            126 // Alert Indication
#define EVT_CC_FACILITY_IND         127 // Facility Indication
#define EVT_CC_FACILITY_CONF        128 // Facility Confirmation

// Currently, NTiEventCC uses events ranged from CC_EVENT_BASE to CC_EVENT_MAX

#endif

// End of NTiEventCC.h
