#include "brd_generic.h"
#include "brd_dialogic_code.h"

/* -------------------------------------------------------------------------
   Name:        CreateInstance

   Purpose:     This function must be implemented in the board DLL to create
                an instance of the specific board class.

                The board class must derive from the "BoardGeneric" class.

                TeleFlow server will call the CreateInstance function in the
                board DLL to create a new instance of the specific board
                class.
   ------------------------------------------------------------------------- */
BoardGeneric* CreateInstance(PIVRINFO pInfo)
{
   BoardGeneric* gen;

   gen = new BrdDialogic(pInfo);
   return gen;
}
/*CreateInstance*/

/* -------------------------------------------------------------------------
   Name:        ReleaseInstance
   ------------------------------------------------------------------------- */
void ReleaseInstance(BoardGeneric* brd)
{
   delete (BrdDialogic*) brd;
}
/*ReleaseInstance*/
