#include "brd_simulator_communication.h"

BoardSimulatorCommunicationPacket::BoardSimulatorCommunicationPacket(BRD_SIMULATOR_EVENT event)
   : event(event)
{
}

const char* BoardSimulatorCommunicationPacket::GetEventName(BoardSimulatorCommunicationPacket::BRD_SIMULATOR_EVENT event)
{
	switch(event)
   {
   	case BoardSimulatorCommunicationPacket::BRD_SIMULATOR_RING: return("BRD_SIMULATOR_RING");
      case BoardSimulatorCommunicationPacket::BRD_SIMULATOR_DIGIT: return("BRD_SIMULATOR_DIGIT");
      case BoardSimulatorCommunicationPacket::BRD_SIMULATOR_ON_HOOK: return("BRD_SIMULATOR_ON_HOOK");
      case BoardSimulatorCommunicationPacket::BRD_SIMULATOR_OFF_HOOK: return("BRD_SIMULATOR_OFF_HOOK");
      case BoardSimulatorCommunicationPacket::BRD_SIMULATOR_CED: return("BRD_SIMULATOR_CED");
      case BoardSimulatorCommunicationPacket::BRD_SIMULATOR_SIT: return("BRD_SIMULATOR_SIT");
      case BoardSimulatorCommunicationPacket::BRD_SIMULATOR_BUSY: return("BRD_SIMULATOR_BUSY");
      case BoardSimulatorCommunicationPacket::BRD_SIMULATOR_NO_ANSWER: return("BRD_SIMULATOR_NO_ANSWER");
      case BoardSimulatorCommunicationPacket::BRD_SIMULATOR_PLAYRECORD_DONE: return("BRD_SIMULATOR_PLAYRECORD_DONE");
      case BoardSimulatorCommunicationPacket::BRD_SIMULATOR_INTERRUPTPLAYRECORD: return("BRD_SIMULATOR_INTERRUPTPLAYRECORD");
      case BoardSimulatorCommunicationPacket::BRD_SIMULATOR_CHANGE_SHORT_AUDIO_LENGTH: return("BRD_SIMULATOR_CHANGE_SHORT_AUDIO_LENGTH");
      case BoardSimulatorCommunicationPacket::BRD_SIMULATOR_BARGEIN: return("BRD_SIMULATOR_BARGEIN");
      case BoardSimulatorCommunicationPacket::BRD_SIMULATOR_AUDIO_CHUNK_FINISHED: return("BRD_SIMULATOR_AUDIO_CHUNK_FINISHED");
      default: return("Unknown");
   }
}

const char* BoardSimulatorCommunicationPacket::GetEventName(void)
{
   return(GetEventName(event));
}
