#include "step_srflagresult.h"
#include "..\Voice\Voice.h"

StepSRFlagResult::StepSRFlagResult(STEPREC& stepRecord) : Step(stepRecord)
{
   SRHandle = stepRecord.s1.arr;
}

StepSRFlagResult::~StepSRFlagResult(void)
{
}

const char* StepSRFlagResult::GetStepName(void) const
{
	return("SR Flag Result");
}

IV_STATUS StepSRFlagResult::Execute(PIVRINFO pInfo)
{
   IV_STATUS status;
   char* value;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if(pInfo->speechRecognition == NULL)
    {
      pInfo->ivLog->Print("      ERROR: No speech recognition module loaded\n");
      pInfo->ivLog->Print("         Make sure to use SR Acquire before SR steps\n");
      return(IVR_FATAL);
   }

   if((value = pInfo->variables->ParseParameter("Invalid SRHandle", SRHandle.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   // Flag SR result indicated by Handle in SpeechTrainer data
   // --------------------------------------------------------
   status = pInfo->speechRecognition->SRFlagResult(value) ? IVR_SUCCESS : IVR_FATAL;
   delete[] value;

   return(status);
}
