#include "..\inet\Socket.h"
#include "..\BoardDLLs\brd_generic.h"  // ProcessSystemEvent()
#include "step_TCPIPDisconnect.h"

StepTCPIPDisconnect::StepTCPIPDisconnect(STEPREC& stepRecord) : Step(stepRecord)
{
   socketHandle = stepRecord.s1.arr;
}

StepTCPIPDisconnect::~StepTCPIPDisconnect(void)
{
}

const char* StepTCPIPDisconnect::GetStepName(void) const
{
	return("TCP Disconnect");
}

IV_STATUS StepTCPIPDisconnect::Execute(PIVRINFO pInfo)
{
   char* value;
   TCPSocket* socket;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((value = pInfo->variables->ParseParameter("Socket handle", socketHandle.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   socket = TCPSocket::GetSocket((ACE_HANDLE) atoi(value));
   delete[] value;

   if(socket != NULL)
   {
      socket->Close();
      delete socket;
   }

   return(IVR_SUCCESS);
 }
 