#include <io.h>
#include "step_createdir.h"
#include "..\BoardDLLs\brd_generic.h"
#include "string.h"
#include "..\escutil\file_fns.h"

StepCreateDir::StepCreateDir(STEPREC& stepRecord) : Step(stepRecord)
{
   dirNm = stepRecord.s6.arr;
}

StepCreateDir::~StepCreateDir(void)
{
}

const char* StepCreateDir::GetStepName(void) const
{
	return("Create Folder");
}

IV_STATUS StepCreateDir::Execute(PIVRINFO pInfo)
{
   IV_STATUS status;
   char* value;
   char* pathName;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((value = pInfo->variables->ParseParameter("Directory", dirNm.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   pathName = pInfo->variables->FilePath(value);
   delete[] value;

   if(access(pathName, 0))
   {
      if(mkdir(pathName) == 0)
      {
         if(strchr(dirNm.c_str(), '@') != NULL)
         {
            pInfo->ivLog->Print("      Creating directory '%s' \n", dirNm.c_str());
         }
         pInfo->ivLog->Print("      Creating directory '%s' \n", pathName);
         status = IVR_SUCCESS;
      }
      else
      {
         status = IVR_FAIL;
      }
   }
   else
   {
      pInfo->ivLog->Print("      WARNING: directory '%s' already exists\n", pathName);
      status = IVR_SUCCESS;
   }

   delete[] pathName;

   return(status);
}
