#include "..\BoardDLLs\brd_generic.h"
#include "step_permitstreaming.h"

StepPermitStreaming::StepPermitStreaming(STEPREC& stepRecord) : Step(stepRecord)
{
   // Default value of 0 indicates streaming is permitted (i.e. true)
   permission = !((bool) stepRecord.u1);
}

StepPermitStreaming::~StepPermitStreaming(void)
{
}

const char* StepPermitStreaming::GetStepName(void) const
{
	return("Streaming");
}

IV_STATUS StepPermitStreaming::Execute(PIVRINFO pInfo)
{
   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   pInfo->ivLog->Print("      Streaming %s\n", permission ? "enabled" : "disabled");

   return(pInfo->ivBoard->PermitStreaming(permission));
 }
