#include <stdlib.h>             // Needed for "atoi".
#include "step_xmlend.h"
#include "..\xmlutil\xmllist.h"

StepXMLEnd::StepXMLEnd(STEPREC& stepRecord) : Step(stepRecord)
{
   handle = stepRecord.s1.arr;
}

StepXMLEnd::~StepXMLEnd(void)
{
}

const char* StepXMLEnd::GetStepName(void) const
{
	return("XML End");
}

IV_STATUS StepXMLEnd::Execute(PIVRINFO pInfo)
{
   char* value;
   int iHandle;
   XML* pxmlReq;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if(pInfo->xmlList == NULL)
   {
      pInfo->ivLog->Print("      ERROR: XML not initialized.\n");
      return(IVR_FATAL);
   }

   // --- Retrieve handle number
   if((value = pInfo->variables->ParseParameter("Handle", handle.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   iHandle = atoi(value);
   delete[] value;
   pInfo->ivLog->Print("      Close handle %d\n", iHandle);

   // --- Search for previous XML document open under this handle,
   //     and if found, close it.
   pInfo->ivLog->Print("         searching XML list...\n");   // @@@ DEBUG
   pxmlReq = pInfo->xmlList->FindXML (iHandle);
   pInfo->ivLog->Print("         searching XML list done\n");   // @@@ DEBUG
   pInfo->ivLog->Print("         deleting, pxmlReq = 0x%x\n", pxmlReq);   // @@@ DEBUG
   delete pxmlReq;
   pInfo->ivLog->Print("         pxmlReq deleted\n");   // @@@ DEBUG
   return(IVR_SUCCESS);
}
/*StepXMLEnd::Execute*/
