#include <algorithm>
using std::transform;

#include "vce_list.h"

VoiceLink::VoiceLink(void)
{
}

VoiceList::VoiceList(void)
{
}

void VoiceList::Add(const char* scriptCode, VoiceLink link)
{
   string ucScriptCode;

   if(scriptCode != NULL)
   {
      ucScriptCode = scriptCode;

      // Make scriptCode uppercase
      transform(ucScriptCode.begin(), ucScriptCode.end(), ucScriptCode.begin(), toupper);

      list[ucScriptCode] = link;
   }
}

const char* VoiceList::GetSimulatorFileName(const char* scriptCode)
{
   string ucScriptCode;

   if(scriptCode == NULL)
   {
      return(NULL);
   }

   ucScriptCode = scriptCode;

   // Make scriptCode uppercase
   transform(ucScriptCode.begin(), ucScriptCode.end(), ucScriptCode.begin(), toupper);

   if(list.count(ucScriptCode) == 0)
   {
      return(NULL);
   }

   return(list[ucScriptCode].SimulatorFileName.c_str());
}

const char* VoiceList::GetTelephonyFileName(const char* scriptCode)
{
   string ucScriptCode;

   if(scriptCode == NULL)
   {
      return(NULL);
   }

   ucScriptCode = scriptCode;

   // Make scriptCode uppercase
   transform(ucScriptCode.begin(), ucScriptCode.end(), ucScriptCode.begin(), toupper);

   if(list.count(ucScriptCode) == 0)
   {
      return(NULL);
   }

   return(list[ucScriptCode].TelephonyFileName.c_str());
}

SOUND_FORMAT VoiceList::GetFormat(const char* scriptCode)
{
   string ucScriptCode;

   if(scriptCode == NULL)
   {
      return(TF_BY_EXTENSION);
   }

   ucScriptCode = scriptCode;

   // Make scriptCode uppercase
   transform(ucScriptCode.begin(), ucScriptCode.end(), ucScriptCode.begin(), toupper);

   if(list.count(ucScriptCode) == 0)
   {
      return(TF_BY_EXTENSION);
   }

   return(list[ucScriptCode].Format);
}
