//---------------------------------------------------------------------------
#ifndef mon_mainH
#define mon_mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include "..\TFServer\ivr_defs.h"
#include "monevent.h"
#include "..\inet\inet_msg.h"

#if 0
// These must be in the same order that they are loaded.
enum LINE_STATUS { lsEmpty, lsNormal, lsWarning, lsCrashed, lsNotRunning };

// String sizes must match with "CLIENT_MSG".
typedef struct
{
   int          status;
   int          appID;
   char         appNm[TELEFLOW_APP_NAME_MAX + 1];
   char         appFile[TELEFLOW_TAP_NAME_MAX + 1];
   char         procNm[31];
   char         stepNo[10];
   char         stepName[31];
   char         stepData[41];
   char         lineNo[10];
} SLOTINFO;

// This number should be the same in brd_XXX.dll, LineList, and TFMonitor.
#define MAXSLOTS   300
extern SLOTINFO MonSlots[MAXSLOTS];
#endif

enum COLUMNS { APP_STATUS,
               APP_NAME,
               APP_RESTART_COUNT,
					APP_TAP,
					APP_TAM,
					APP_STEP_NUMBER,
					APP_STEP_NAME,
					APP_DATA,
					APP_PORT };

// Registry key where TeleFlow Monitor settings are stored
#define TFMONITOR_REG_KEY  TELEFLOW_REG_KEY "\\TeleFlow Monitor"

#define INFOLOG_MAX 200
typedef struct
{
   char	currentTAMName[31];
   long  stepNo;
   char	stepName[31];
   long  lineNo;
} LogSlotInfo;

typedef struct
{
	LogSlotInfo log[INFOLOG_MAX];
   int			index;
   bool			logWrapped;
} InfoLog;

//---------------------------------------------------------------------------
class TFormMon : public TForm
{
__published:	// IDE-managed Components
    TPanel *pnlClient;
    TDrawGrid *gridEng;
    TMainMenu *mnuMain;
    TMenuItem *mnuFile;
    TMenuItem *mnuFileExit;
    TMenuItem *mnuHelp;
    TMenuItem *mnuHelpAbout;
    TImageList *imgListLights;
        TMenuItem *mnuApplication;
        TMenuItem *mnuApplicationSDNormal;
        TMenuItem *mnuApplicationSDAbort;
        TMenuItem *mnuApplicationLoadNormal;
        TMenuItem *mnuApplicationLoadAbort;
        TMenuItem *mnuApplicationSDAllNormal;
        TMenuItem *mnuApplicationSDAllAbort;
    TStatusBar *sbarInfo;
        TMenuItem *mnuViewRefresh;
        TMenuItem *mnuConnectionConnect;
        TMenuItem *mnuConnectionDisconnect;
        TMenuItem *mnuApplicationShowMsgs;
    TPopupMenu *mnuGrid;
    TMenuItem *mnuGridSDNormal;
    TMenuItem *mnuGridSDAbort;
    TMenuItem *mnuGridLoadNormal;
    TMenuItem *mnuGridLoadAbort;
    TMenuItem *mnuGridShowMsgs;
        TMenuItem *mnuFileOptions;
        TMenuItem *mnuConnection;
        TMenuItem *mnuView;
        TMenuItem *mnuApplicationReloadAllNormal;
        TMenuItem *mnuApplicationReloadAllAbort;
   TTimer *TimerRefresh;
	TMenuItem *mnuFileReloadTAL;
   TMenuItem *t1;
    void __fastcall gridEngDrawCell(TObject *Sender, int Col, int Row,
          TRect &Rect, TGridDrawState State);
    void __fastcall mnuApplicationSDNormalClick(TObject *Sender);
    void __fastcall mnuApplicationSDAbortClick(TObject *Sender);
    void __fastcall mnuApplicationLoadNormalClick(TObject *Sender);
    void __fastcall mnuApplicationLoadAbortClick(TObject *Sender);
    void __fastcall mnuApplicationSDAllNormalClick(TObject *Sender);
    void __fastcall mnuApplicationSDAllAbortClick(TObject *Sender);
    void __fastcall mnuFileExitClick(TObject *Sender);
    void __fastcall sbarInfoDrawPanel(TStatusBar *StatusBar,
          TStatusPanel *Panel, const TRect &Rect);
    void __fastcall gridEngSelectCell(TObject *Sender, int Col, int Row,
          bool &CanSelect);
    void __fastcall mnuViewRefreshClick(TObject *Sender);
    void __fastcall mnuConnectionConnectClick(TObject *Sender);
    void __fastcall mnuConnectionDisconnectClick(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall gridEngMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall mnuApplicationClick(TObject *Sender);
    void __fastcall mnuHelpAboutClick(TObject *Sender);
        void __fastcall mnuApplicationShowMsgsClick(TObject *Sender);
        void __fastcall mnuGridShowMsgsClick(TObject *Sender);
        void __fastcall mnuFileOptionsClick(TObject *Sender);
   void __fastcall mnuApplicationReloadAllNormalClick(TObject *Sender);
   void __fastcall mnuApplicationReloadAllAbortClick(TObject *Sender);
   void __fastcall TimerRefreshTimer(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall mnuFileReloadTALClick(TObject *Sender);
   void __fastcall t1Click(TObject *Sender);
private:	// User declarations
    bool        bPleaseClose;  // Set when application is trying to close.
    bool        bWaitForReply; // Set when waiting for a host to reply.
    bool			 bConnectedToHost;
    char*       autoConnectHost;
    unsigned int appNumber; // Number of apps running on server
    LINE_STATUS lsCurrentLine;
    Head        msgHead;

    void __fastcall SetupGrid();
//  void __fastcall SetupLights();
    void __fastcall UpdateStatusMessage();
    void __fastcall SendMsgForApp (int appID, int netEvent);
    void __fastcall SendMsgForAllApps (int netEvent);
    void __fastcall ShowStatusDialog (bool bShow, char *msg = 0);
    void __fastcall WriteRegistry(void);
    void __fastcall ReadRegistry(void);
	 void __fastcall ClearGrid(void);
    bool __fastcall DumpPacketLogs(void);		// For debugging purposes
    void __fastcall ConfigureMenus(void);

protected:
    void __fastcall WndProc(Messages::TMessage &Message);
public:		// User declarations
	CLIENT_MSG        clientMsgs[MAX_CLIENTS];
   Graphics::TColor  threadColour;
   bool bPleaseReconnect;
   bool bAutoConnect;  // True when application connects to autoConnectHost upon start
   bool bAutoReconnect;// True when we should reconnect automatically after being disconnect from the server
   short connectionPort;
   unsigned int refreshInterval;  // milliseconds between refreshes of entire grid, single line refresh per event when set to 0
   bool bFatMonitor;
   bool bLogPackets;
	InfoLog appLogs[MAX_CLIENTS];		// For debugging purposes
   bool bReadOnly;

    __fastcall TFormMon(TComponent* Owner);
    __fastcall ~TFormMon();
    void __fastcall InvalidateRow (int iRow);
    void __fastcall SetPanelMessage (char *msg);
    void __fastcall EnableSocketMenu (bool bEnable);
    void __fastcall ThreadDone();
    void __fastcall MsgWindowClosed (int appID);
    void __fastcall MsgDisplayLines (int appID, char *lines);
    void __fastcall DisplayError (char *errorMsg);
    void __fastcall ConnectAuto(char* host = NULL);
    void __fastcall ResizeGrid(unsigned int rows);
	 void __fastcall SetConnectedToHost(bool connected);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormMon *FormMon;
//---------------------------------------------------------------------------
#endif
