//---------------------------------------------------------------------------

#include <winsock2.h>   // Included before vcl.h to prevent conflict with ACE socket files

#include <vcl.h>
#pragma hdrstop

#include "..\BoardDLLs\brd_simulator_code.h" // SIMULATOR_EVENT
#include "TFSimulator_placecall.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPlaceCallForm *PlaceCallForm;
//---------------------------------------------------------------------------
__fastcall TPlaceCallForm::TPlaceCallForm(TComponent* Owner)
   : TForm(Owner)
{
   LoadJPGFromResource(OnHookImage, "TeleOnHook");
   LoadJPGFromResource(PlaceCallPanelImage, "Panel3");
   LoadJPGFromResource(AnswerImage, "ButtAnswerU");
   LoadJPGFromResource(AnswerDownImage, "ButtAnswerP");
   LoadJPGFromResource(DontAnswerImage, "ButtNoanswerU");
   LoadJPGFromResource(DontAnswerDownImage, "ButtNoanswerP");
   LoadJPGFromResource(RingsImage, "ButtRingsU");
   LoadJPGFromResource(RingsDownImage, "ButtRingsP");
   LoadJPGFromResource(BusyImage, "ButtBusyU");
   LoadJPGFromResource(BusyDownImage, "ButtBusyP");
   LoadJPGFromResource(SITImage, "ButtSITU");
   LoadJPGFromResource(SITDownImage, "ButtSITP");
   LoadJPGFromResource(CEDImage, "ButtCEDU");
   LoadJPGFromResource(CEDDownImage, "ButtCEDP");
   simulator = NULL;
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::LoadJPGFromResource(TImage* image, const char* jpgName)
{
   TResourceStream* JPGStream = new TResourceStream((int) HInstance, jpgName, "JPGIMAGE");
   TJPEGImage* JPGImage = new TJPEGImage();
   JPGImage->LoadFromStream(JPGStream);
   image->Picture->Bitmap->Assign(JPGImage);
   delete JPGImage;
   delete JPGStream;
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::GetResponse(TFormSimulator* _simulator)
{
   simulator = _simulator;
   FirstButtonSet();
   Show();
}
//---------------------------------------------------------------------------
void __fastcall TPlaceCallForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   if(simulator != NULL)
   {
      simulator->SendEvent(BoardSimulatorCommunicationPacket::BRD_SIMULATOR_NO_ANSWER);
   }

   simulator = NULL;
   Hide();
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::FirstButtonSet(void)
{
   AnswerPanel->Hide();
   DontAnswerPanel->Hide();
   RingsPanel->Show();
   BusyPanel->Show();
   SITPanel->Show();
   CEDPanel->Show();
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::SecondButtonSet(void)
{
   RingsPanel->Hide();
   BusyPanel->Hide();
   SITPanel->Hide();
   CEDPanel->Hide();
   AnswerPanel->Show();
   DontAnswerPanel->Show();
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::AnswerImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   AnswerImage->Hide();
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::AnswerImageMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   AnswerImage->Show();

   if(simulator != NULL)
   {
      simulator->SendEvent(BoardSimulatorCommunicationPacket::BRD_SIMULATOR_OFF_HOOK);
   }

   simulator = NULL;
   Hide();
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::BusyImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   BusyImage->Hide();
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::BusyImageMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   BusyImage->Show();
   BusyImage->Repaint();

   if(simulator != NULL)
   {
      simulator->SendEvent(BoardSimulatorCommunicationPacket::BRD_SIMULATOR_BUSY);
   }

   PlaySound("BUSYSIGNAL", HInstance, SND_RESOURCE);

   simulator = NULL;
   Hide();
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::DontAnswerImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   DontAnswerImage->Hide();
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::DontAnswerImageMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   DontAnswerImage->Show();

   Close();
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::RingsImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   RingsImage->Hide();
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::RingsImageMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   RingsImage->Show();
   BusyImage->Repaint();

   SecondButtonSet();

   PlaySound("RINGIN", HInstance, SND_RESOURCE | SND_ASYNC);
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::SITImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   SITImage->Hide();
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::SITImageMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   SITImage->Show();
   BusyImage->Repaint();

   if(simulator != NULL)
   {
      simulator->SendEvent(BoardSimulatorCommunicationPacket::BRD_SIMULATOR_SIT);
   }

   PlaySound("SIT", HInstance, SND_RESOURCE);

   simulator = NULL;
   Hide();
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::CEDImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   CEDImage->Hide();
}
//---------------------------------------------------------------------------

void __fastcall TPlaceCallForm::CEDImageMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   CEDImage->Show();

   if(simulator != NULL)
   {
      simulator->SendEvent(BoardSimulatorCommunicationPacket::BRD_SIMULATOR_CED);
   }

   PlaySound("CED", HInstance, SND_RESOURCE);

   simulator = NULL;
   Hide();
}
//---------------------------------------------------------------------------

